searchData={"items":[{"type":"module","title":"Fernet.Ecto","doc":"[Fernet](https://github.com/kennyp/fernetex)-encrypted fields for Ecto.","ref":"Fernet.Ecto.html"},{"type":"module","title":"Defining a Fernet-encrypted field - Fernet.Ecto","doc":"A Fernet-encrypted field can be defined on a schema just like any other Ecto\nfield:\n\n    defmodule MyApp.User do\n      use Ecto.Schema\n\n      schema \"users\" do\n        field :name,         :string\n        field :secret,       Fernet.Ecto.String\n        field :more_secrets, Fernet.Ecto.Map\n      end\n    end\n\nBoth `Fernet.Ecto.String` and `Fernet.Ecto.Map` are stored in `:binary`\ncolumns in the database:\n\n    defmodule MyApp.Repo.Migrations.CreateUsers do\n      use Ecto.Migration\n\n      def up do\n        create table(:users) do\n          add :name,         :text\n          add :secret,       :binary\n          add :more_secrets, :binary\n        end\n      end\n\n      def down do\n        drop table(:users)\n      end\n    end","ref":"Fernet.Ecto.html#module-defining-a-fernet-encrypted-field"},{"type":"module","title":"Configuring key and TTL values - Fernet.Ecto","doc":"`Fernet.Ecto` types fetch the key and TTL values used when Fernet encrypting\nand decrypting values from the application environment.  The most basic\nconfiguration is a single key defined in `config.exs`:\n\n    config :fernet_ecto, key: \"lyvBTUSkoEICefeuGZtAsILhZ25qotIqdHS5C1n6qDw=\"\n\nA TTL (in seconds) can also be defined.  The TTL is used in the decryption\nverification phase to ensure that the loaded data wasn't encrypted too far\nin the past:\n\n    config :fernet_ecto, ttl: 3600","ref":"Fernet.Ecto.html#module-configuring-key-and-ttl-values"},{"type":"module","title":"Credential rotation - Fernet.Ecto","doc":"Multiple keys can be defined using a list:\n\n    config :fernet_ecto, key: [\"HJ6dYDfyNmIRAjWLMUj_3zS8W9XkfWiln8DzpkxWACE=\",\n                               \"lyvBTUSkoEICefeuGZtAsILhZ25qotIqdHS5C1n6qDw=\"]\n\nThe first available key is always used when encrypting values to store in\nthe database.  When values are loaded from the database the available keys\nwill be tried in order to decrypt and verify the data.  A `RuntimeError` is\nraised if none of the available keys can be used to decrypt and verify the\nloaded data.\n\nThe key can be rotated by first adding a new key and then loading every\nencrypted value from the database to decode it using the old key, and then\nwriting it back to the database to encode it using the new key.  Once this\nprocedure has been completed the old key can be removed from the\nconfiguration.","ref":"Fernet.Ecto.html#module-credential-rotation"},{"type":"module","title":"Fernet.Ecto.Map","doc":"An Ecto type for Fernet-encrypted maps.","ref":"Fernet.Ecto.Map.html"},{"type":"function","title":"Fernet.Ecto.Map.cast/1","doc":"Only accept map values.","ref":"Fernet.Ecto.Map.html#cast/1"},{"type":"function","title":"Fernet.Ecto.Map.dump/1","doc":"Encrypt a map to store in the database.","ref":"Fernet.Ecto.Map.html#dump/1"},{"type":"function","title":"Fernet.Ecto.Map.embed_as/1","doc":"","ref":"Fernet.Ecto.Map.html#embed_as/1"},{"type":"function","title":"Fernet.Ecto.Map.equal?/2","doc":"","ref":"Fernet.Ecto.Map.html#equal?/2"},{"type":"function","title":"Fernet.Ecto.Map.load/1","doc":"Decrypt a map loaded from the database.","ref":"Fernet.Ecto.Map.html#load/1"},{"type":"function","title":"Fernet.Ecto.Map.type/0","doc":"Fernet-encrypted data is stored as a binary in the database.","ref":"Fernet.Ecto.Map.html#type/0"},{"type":"module","title":"Fernet.Ecto.String","doc":"An Ecto type for Fernet-encrypted strings.","ref":"Fernet.Ecto.String.html"},{"type":"function","title":"Fernet.Ecto.String.cast/1","doc":"Only accept binary and string plaintext values.","ref":"Fernet.Ecto.String.html#cast/1"},{"type":"function","title":"Fernet.Ecto.String.dump/1","doc":"Encrypt a value to store in the database.","ref":"Fernet.Ecto.String.html#dump/1"},{"type":"function","title":"Fernet.Ecto.String.embed_as/1","doc":"","ref":"Fernet.Ecto.String.html#embed_as/1"},{"type":"function","title":"Fernet.Ecto.String.equal?/2","doc":"","ref":"Fernet.Ecto.String.html#equal?/2"},{"type":"function","title":"Fernet.Ecto.String.load/1","doc":"Decrypt a value loaded from the database.","ref":"Fernet.Ecto.String.html#load/1"},{"type":"function","title":"Fernet.Ecto.String.type/0","doc":"Fernet-encrypted data is stored as a binary in the database.","ref":"Fernet.Ecto.String.html#type/0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}